#define _SUPPRESS_PLIB_WARNING
#include <plib.h>
#include "cfunctions.h"

long long readADCtoArray(
        long long *chan,
        long long *array,
        long long *elements,
        long long *delay)
{
    unsigned int pin = *chan;
    unsigned int e,
                 wait = *delay; //takes 248 ticks to read ADC @48MHz CPU speed
    unsigned int zero_ticks, 
                 current_ticks,
                 sum_ticks=0;
                                           
    // set the core timer to zero (s. delay.c)
    asm volatile("mfc0 %0, $9": "=r"(zero_ticks));

    for(e=0;e<=*elements;e++) {
     array[e] = ExtInp(pin);//wait;
     do {// get the core timer ticks
          asm volatile("mfc0 %0, $9": "=r"(current_ticks));
        } while(current_ticks < wait);
     sum_ticks+=current_ticks;
     // set the core timer to zero (s. delay.c)
     asm volatile("mfc0 %0, $9": "=r"(zero_ticks));     
    }
 return (sum_ticks); // return sum of ticks
}